The class is used to create window wizard form
Beispiel #1
0
        /// <summary>
        /// Implement this method as an external command for Revit.
        /// </summary>
        /// <param name="commandData">An object that is passed to the external application
        /// which contains data related to the command,
        /// such as the application object and active view.</param>
        /// <param name="message">A message that can be set by the external application
        /// which will be displayed if a failure or cancellation is returned by
        /// the external command.</param>
        /// <param name="elements">A set of elements to which the external application
        /// can add elements that are to be highlighted in case of failure or cancellation.</param>
        /// <returns>Return the status of the external command.
        /// A result of Succeeded means that the API external method functioned as expected.
        /// Cancelled can be used to signify that the user cancelled the external operation
        /// at some point. Failure should be returned if the application is unable to proceed with
        /// the operation.</returns>
        public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData,
                                                ref string message,
                                                ElementSet elements)
        {
            Document doc = commandData.Application.ActiveUIDocument.Document;

            //only a family document  can retrieve family manager
            if (doc.IsFamilyDocument)
            {
                if (null != doc.OwnerFamily && null != doc.OwnerFamily.FamilyCategory &&
                    doc.OwnerFamily.FamilyCategory.Name != doc.Settings.Categories.get_Item(BuiltInCategory.OST_Windows).Name)
                // FamilyCategory.Name is not "Windows".
                {
                    message = "Please make sure you opened a template of Window.";
                    return(Autodesk.Revit.UI.Result.Failed);
                }
                WindowWizard wizard = new WindowWizard(commandData);
                int          result = wizard.RunWizard();
                if (1 == result)
                {
                    return(Autodesk.Revit.UI.Result.Succeeded);
                }
                else if (0 == result)
                {
                    message = "Window Creation was cancelled.";
                    return(Autodesk.Revit.UI.Result.Cancelled);
                }
                else
                {
                    message = "Window Creation failed, please check your template and inputs then try again.";
                    return(Autodesk.Revit.UI.Result.Failed);
                }
            }
            else
            {
                message = "please make sure you have opened a family document!";
                return(Autodesk.Revit.UI.Result.Failed);
            }
        }
Beispiel #2
0
        /// <summary>
        /// Implement this method as an external command for Revit.
        /// </summary>
        /// <param name="commandData">An object that is passed to the external application 
        /// which contains data related to the command, 
        /// such as the application object and active view.</param>
        /// <param name="message">A message that can be set by the external application 
        /// which will be displayed if a failure or cancellation is returned by 
        /// the external command.</param>
        /// <param name="elements">A set of elements to which the external application 
        /// can add elements that are to be highlighted in case of failure or cancellation.</param>
        /// <returns>Return the status of the external command. 
        /// A result of Succeeded means that the API external method functioned as expected. 
        /// Cancelled can be used to signify that the user cancelled the external operation 
        /// at some point. Failure should be returned if the application is unable to proceed with 
        /// the operation.</returns>
        public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData,
                                             ref string message,
                                             ElementSet elements)
        {
            Document doc = commandData.Application.ActiveUIDocument.Document;

            //only a family document  can retrieve family manager
            if (doc.IsFamilyDocument)
            {
                if (null != doc.OwnerFamily && null != doc.OwnerFamily.FamilyCategory&&!doc.OwnerFamily.FamilyCategory.Name.Contains("Window"))
                {
                    message = "Please make sure you opened a template of Window.";
                    return Autodesk.Revit.UI.Result.Failed;
                }
                WindowWizard wizard = new WindowWizard(commandData);
                int result = wizard.RunWizard();
                if (1 == result)
                {
                    return Autodesk.Revit.UI.Result.Succeeded;
                }
                else if (0 == result)
                {
                    message = "Window Creation was cancelled.";
                    return Autodesk.Revit.UI.Result.Cancelled;
                }
                else
                {
                    message = "Window Creation failed, please check your template and inputs then try again.";
                    return Autodesk.Revit.UI.Result.Failed;
                }
            }
            else
            {
                message = "please make sure you have opened a family document!";
                return Autodesk.Revit.UI.Result.Failed;
            }
        }